#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>
#include <string>
#include <dirent.h>
#include "fonction.h"

using namespace std;

int main(int argc, char *argv[])
{
	SDL_Init(SDL_INIT_VIDEO);
	TTF_Init();

	SDL_WM_SetCaption("3D to C", NULL);

	SDL_Surface *ecran = SDL_SetVideoMode(400, 400, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
	SDL_Surface *main_img = IMG_Load("data/programme.png");
	SDL_Surface *cadre_img = IMG_Load("data/cadre.png");

	SDL_Rect background_pos; background_pos.x = 0; background_pos.y = 0;
	SDL_Rect whereis_txt_output_pos; whereis_txt_output_pos.x = 13; whereis_txt_output_pos.y = 220;
	SDL_Rect whereis_txt_input_pos; whereis_txt_input_pos.x=13; whereis_txt_input_pos.y = 163;
	SDL_Rect output_txt_pos;output_txt_pos.x=17;output_txt_pos.y=239;
	SDL_Rect input_txt_pos;input_txt_pos.x=17;input_txt_pos.y=183;
	SDL_Rect cadre_pos;cadre_pos.x=350;cadre_pos.y=0;
	SDL_Rect inprogress_pos;inprogress_pos.x=145;inprogress_pos.y=318;

	FILE *file_origine = NULL;
	FILE *file_out = NULL;
	FILE *file_text = fopen("./data/text.txt", "r");
	char whereis_input_txt[100], whereis_output_txt[100], output[200]="", input[200]="";
	fgets(whereis_input_txt, 100, file_text);
	fgets(whereis_output_txt, 100, file_text);
	fclose(file_text);
	clean_char(whereis_input_txt);
	clean_char(whereis_output_txt);

	SDL_Color couleurGris = {50, 50, 50};
	TTF_Font *police = TTF_OpenFont("data/Vera.ttf", 12);
	SDL_Surface *whereis_texte_input = TTF_RenderText_Blended(police, whereis_input_txt, couleurGris);
	SDL_Surface *whereis_texte_output = TTF_RenderText_Blended(police, whereis_output_txt, couleurGris);
	SDL_Surface *output_txt = TTF_RenderText_Blended(police, output, couleurGris);
	SDL_Surface *input_txt = TTF_RenderText_Blended(police, input, couleurGris);
	SDL_Surface *complete_img = TTF_RenderText_Blended(police, "Convert complete!", couleurGris);

	char continuer = 1, convertir = 0, appuis = 0, fenetre = 0;
	int word_input = 0, word_output = 0, p=0, q=0;

	SDL_Event event;
	Uint8 *keystates = SDL_GetKeyState(NULL);

	struct dirent *lecture;
	DIR *rep;


	while (continuer == 1)
	{
	SDL_BlitSurface(main_img, NULL, ecran, &background_pos);
	SDL_BlitSurface(whereis_texte_input, NULL, ecran, &whereis_txt_input_pos);
	SDL_BlitSurface(whereis_texte_output, NULL, ecran, &whereis_txt_output_pos);
	SDL_BlitSurface(output_txt, NULL, ecran, &output_txt_pos);
	SDL_FreeSurface(output_txt);
	output_txt = TTF_RenderText_Blended(police, output, couleurGris);
	SDL_BlitSurface(input_txt, NULL, ecran, &input_txt_pos);
	SDL_FreeSurface(input_txt);
	input_txt = TTF_RenderText_Blended(police, input, couleurGris);
	SDL_BlitSurface(cadre_img, NULL, ecran, &cadre_pos);

		if ((convertir == 0) || (convertir==3))//main windows with available action
		{
			while (SDL_PollEvent(&event));
			{
			check_for_action(&event, &fenetre, &convertir);
			blit_cadre(&event, &cadre_pos);

				if (fenetre==1) (enter_path(input, &word_input, keystates, &appuis, &event));
				else if (fenetre==2) (enter_path(output, &word_output, keystates, &appuis, &event));
			}
			if (convertir==3) (SDL_BlitSurface(complete_img,NULL,ecran, &inprogress_pos));
		}
		else if (convertir == 1) //convert a simple file
		{
		file_origine = fopen(input, "r");
		file_out = fopen(output, "w+");
			if (file_origine!=NULL)
			{
				if ((strstr(input, ".obj"))!=NULL)
				{
				obj_to_C(file_out, file_origine, ecran, police);
				}
				else if ((strstr(input, ".ac"))!=NULL)
				{
				ac_to_C(file_out, file_origine, ecran, police);
				}
				else if ((strstr(input, ".off"))!=NULL)
				{
				off_to_C(file_out, file_origine, ecran, police);
				}
				else if ((strstr(input, ".iv"))!=NULL)
				{
				iv_to_C(file_out, file_origine, ecran, police);
				}
			fclose(file_origine);
			}
		fclose(file_out);
		convertir = 3;
		}
		else if (convertir == 2) //the mass conversion
		{
		rep = opendir("./toconvert");
		int i;
			while ((lecture = readdir(rep)))
			{
			sprintf(input,"./toconvert/%s", lecture->d_name);
			file_origine = fopen(input, "r");
			sprintf(output,"./converted/%s", lecture->d_name);
				for(i=200;i>=0;i--)
				{
					if((output[i] == 'c') && (output[i-1] == 'a') && (output[i-2] == '.'))
					{
					output[i] = '\0';
					output[i-1] = 'c';
					}
					if((output[i] == 'j') && (output[i-1] == 'b') && (output[i-2] == 'o') && (output[i-3] == '.'))
					{
					output[i] = '\0';
					output[i-1] = '\0';
					output[i-2] = 'c';
					}
					if((output[i] == 'f') && (output[i-1] == 'f') && (output[i-2] == 'o') && (output[i-3] == '.'))
					{
					output[i] = '\0';
					output[i-1] = '\0';
					output[i-2] = 'c';
					}
					if((output[i] == 'v') && (output[i-1] == 'i') && (output[i-2] == '.'))
					{
					output[i] = '\0';
					output[i-1] = 'c';
					}
				}
				if (file_origine!=NULL)
				{
				file_out = fopen(output, "w+");
					if ((strstr(input, ".obj"))!=NULL)
					{
					obj_to_C(file_out, file_origine, ecran, police);
					}
					else if ((strstr(input, ".ac"))!=NULL)
					{
					ac_to_C(file_out, file_origine, ecran, police);
					}
					else if ((strstr(input, ".off"))!=NULL)
					{
					off_to_C(file_out, file_origine, ecran, police);
					}
					else if ((strstr(input, ".iv"))!=NULL)
					{
					iv_to_C(file_out, file_origine, ecran, police);
					}
				}
			}
		fclose(file_origine);
		fclose(file_out);
		closedir(rep);
		convertir = 3;
		}


	exit_prog(&event, &continuer);
	SDL_Flip(ecran);
	}

    TTF_CloseFont(police);
    TTF_Quit();

    SDL_FreeSurface(whereis_texte_input);
    SDL_FreeSurface(whereis_texte_output);
    SDL_FreeSurface(output_txt);
    SDL_FreeSurface(input_txt);
    SDL_FreeSurface(ecran);
    SDL_FreeSurface(main_img);
    SDL_FreeSurface(cadre_img);
    SDL_Quit();
	return EXIT_SUCCESS;
}
